#include <stdio.h>
#define YES 1
#define NO  0
#define VON   100
#define BIS   250
#define ANZ 5

main()    /* Primzahlberechnung: Sieb des Erathostenes */
{
   short prim_anz[ BIS+1 ];
   int i, j, k, n;

   printf("Berechnung der Primzahlen von %d bis %d: \n", VON, BIS);

   n=BIS; i=2;
   /* Init feld prim_anz */
   while ( i <= n )
      prim_anz[i++] = YES;
   i=2; k=1;
   while ( i <= n ) {
      if (prim_anz[i]) {
        j = i;
        if ( i >= VON )
           printf("  %6d%c", i, k++ % ANZ ? '\t' : '\n');
        while (i*i < n && ( j += i ) <= n )
           prim_anz[j] = NO;
      }
      i++;
   }
   printf("\n");
}
